/*
 * BackchannelUART.h
 *
 *  Created on: Jun 18, 2019
 *      Author: hdevore
 */

#ifndef BACKCHANNELUART_H_
#define BACKCHANNELUART_H_

#include <msp430.h>

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *    Backchannel UART: RXD  P1.1
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *    RXD is the MSP recieves
 *    USCI_A0
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

#define RXD_BIT                     BIT1
#define RXD_PORT                    P1IN
#define RXD_DIR                     P1DIR
#define RXD_REN                     P1REN
#define RXD_PUD                     P1OUT
#define SET_RXD_AS_INPUT            RXD_DIR &= ~RXD_BIT
#define EN_RXD_PUD                  RXD_REN |= RXD_BIT
#define SET_RXD_PULLDOWN            RXD_PUD &= ~RXD_BIT
#define SET_RXD_PULLUP              RXD_PUD |= RXD_BIT
#define RXD_READ                    ((unsigned char) (RXD_PORT & RXD_BIT) >> 1)

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *    Backchannel UART: TXD  P1.2
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *    TXD is the MSP sends
 *    USCI_A0
 *
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

#define TXD_BIT                    BIT2
#define TXD_PORT                   P1OUT
#define TXD_DIR                    P1DIR
#define SET_TXD_AS_OUTPUT          TXD_DIR |= TXD_BIT
#define TXD_HI                     TXD_PORT |= TXD_BIT
#define TXD_LO                     TXD_PORT &= ~TXD_BIT

void InitializeBackchannelUART(void);

// unsigned char ReadValue(void);

void SendValue(unsigned char value);

#endif /* BACKCHANNELUART_H_ */
