/*
 * LED.h
 *
 *  Created on: Jun 18, 2019
 *      Author: hdevore
 */

#ifndef LED_H_
#define LED_H_

#include <msp430.h>

/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *    LED 1
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *   Color:     Green
 *   Polarity:  Active High
 *   Pin:       P1.0
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

#define LED1_BIT                    BIT0
#define LED1_PORT                   P1OUT
#define LED1_DIR                    P1DIR
#define LED1_SEL                    P1SEL
#define SET_LED1_AS_OUTPUT          LED1_DIR |= LED1_BIT
#define SET_LED1_AS_INPUT           LED1_DIR &= ~LED1_BIT
#define SET_LED1_AS_GPIO            LED1_SEL &= ~LED1_BIT
#define LED1_ON                     LED1_PORT |= LED1_BIT
#define LED1_OFF                    LED1_PORT &= ~LED1_BIT


/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *    LED 2
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *   Color:     Red
 *   Polarity:  Active High
 *   Pin:       P1.6
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

#define LED2_BIT                    BIT6
#define LED2_PORT                   P1OUT
#define LED2_DIR                    P1DIR
#define SET_LED2_AS_OUTPUT          LED2_DIR |= LED2_BIT
#define LED2_ON                     LED2_PORT |= LED2_BIT
#define LED2_OFF                    LED2_PORT &= ~LED2_BIT


/* ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *    RGB LED
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 *   Color:     RGB
 *   Polarity:  Active High
 *   Pin:       P2.1, 2.3, 2.5
 * ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 */

#define RGBLED_BITR                 BIT1
#define RGBLED_BITG                 BIT3
#define RGBLED_BITB                 BIT5
#define RGBLED_PORT                 P2OUT
#define RGBLED_DIR                  P2DIR
#define SET_RGBLED_AS_OUTPUT        RGBLED_DIR |= RGBLED_BITR | RGBLED_BITG | RGBLED_BITB
#define RGBLED_ALL_ON               RGBLED_PORT |= (RGBLED_BITR | RGBLED_BITG | RGBLED_BITB)
#define RGBLED_ALL_OFF              RGBLED_PORT &= (~RGBLED_BITR & ~RGBLED_BITG & ~RGBLED_BITB)
#define RGBLED_ALL_TGL              RGBLED_PORT ^= (RGBLED_BITR | RGBLED_BITG | RGBLED_BITB)
#define RGBLED_R_ON                 RGBLED_PORT |= RGBLED_BITR
#define RGBLED_G_ON                 RGBLED_PORT |= RGBLED_BITG
#define RGBLED_B_ON                 RGBLED_PORT |= RGBLED_BITB
#define RGBLED_R_OFF                RGBLED_PORT &= ~RGBLED_BITR
#define RGBLED_G_OFF                RGBLED_PORT &= ~RGBLED_BITG
#define RGBLED_B_OFF                RGBLED_PORT &= ~RGBLED_BITB
#define RGBLED_R_TGL                RGBLED_PORT ^= RGBLED_BITR
#define RGBLED_G_TGL                RGBLED_PORT ^= RGBLED_BITG
#define RGBLED_B_TGL                RGBLED_PORT ^= RGBLED_BITB

void InitializeLEDPortPins(void);



#endif /* LED_H_ */
