#include <msp430.h> 
#include <msp430g2553.h>
#include "LED.h"
#include "BackchannelUART.h"
#include "timerA.h"


/**
 * main.c
 */

extern unsigned char readValue;

void main(void)
{
	WDTCTL = WDTPW | WDTHOLD;	// stop watchdog timer

    //DCOCTL = CALDCO_16MHz;
    //BCSCTL1 = CALBC1_16MHz;

	// no configuration of clock speed is 1000 cycles is 900 us which is .9 us apiece. this is about the same for both the delaycycles method of measurement and the timera method of measurement.

	//DCOCTL = 0x10FE; // value from msp430g2553.cmd for 1 MHz
	//BCSCTL1 = 0x10FF; // 1000 cycles is 50 us which is .05 us apiece which is 20 MHz. both delaycycles and timera methods give 50 us for 1000 cycles.

	//DCOCTL = 0b10000000; // DCO = 4, MODx = 0
	//BCSCTL1 = 0b10000001; // 10 cycles is 100 us so 1 cycle is 10 us
	//BCSCTL1 = 0b10000100; // 10 cycles is 40 us
	//BCSCTL1 = 0b10000110; // 10 cycles is 20 us
	//BCSCTL1 = 0b10000111; // 10 cycles is 15 us

	//DCOCTL = 0b11100000;
	//BCSCTL1 = 0b10000111; // 1000 cycles is about 600 us

	//DCOCTL = 0x10BE;
	//BCSCTL1 = 0x10BF;

	//DCOCTL = 0x0006; // value from the datasheet page 583 for 1 MHz
	//BCSCTL1 = 0x0007; // 1000 cycles is 1050 us (using _delay_cycles and toggling LED)

	//DCOCTL = 0x0016;
	//BCSCTL1 = 0x0017; // 1000 cycles is about 1025 us

	DCOCTL = 0x0026;
	BCSCTL1 = 0x0027; // 1000 cycles is 1000 us, for the main clock (ie delaycycles) and for the timerA method of measurement.

	InitializeLEDPortPins();
	InitializeBackchannelUART();
	_enable_interrupts();
	//ConfigureTimerA0();

	/*
	while (1)
	    {
	        LED1_ON;
	        LED2_ON;
	        _delay_cycles(1000000);
	        LED1_OFF;
	        LED2_OFF;
	        _delay_cycles(1000000);
	} */


	// Debug: Enable loopback mode
	//UCA0STAT = 0b10000000;
	//LED2_ON;
	//RGBLED_G_ON;

	while (1)
	{
	    //SendValue(readValue);
	    //SendValue(0b00000010);
	    /*if (IFG2 & BIT1) // check for an interrupt flag from the RX
	    {
	        readValue = UCA0RXBUF; // read the value
	        //SendValue(readValue); // send back the value read, for debug purposes
	        IFG2 &= 0b11111110; // clear the interrupt flag
	    } */



	    if (readValue != 0b00000000)
	    {
	        LED1_ON;
	    }
	    else
	    {
	        LED1_OFF;
	    }
	    if (readValue == 0b00000001)
	    {
	        LED2_ON;
	    }
	    else
	    {
	        LED2_OFF;
	    }
	    SendValue(readValue);

	    //_delay_cycles(100000);

	    //RGBLED_B_TGL;
	    //_delay_cycles(1000);

	    //SendValue(0b10101010);
	   /* TXD_HI;
	    _delay_cycles(1000);
	    TXD_LO;
	    _delay_cycles(1000); */
	}
}
