/*
 * timerA.c
 *
 *  Created on: Jun 26, 2019
 *      Author: hdevore
 */

#include <msp430.h>
#include "timerA.h"
#include "LED.h"

void ConfigureTimerA0(void)
{


    // stop the timer
    TA0CTL |= MC_0;

    // Clear the timer
    TA0CTL |= TACLR;

    TA0CCR0 = TACCR0_VALUE;


    // enable the TACCR0 compare/capture interrupt flag
    TACCTL0 |= CCIE;

    /*
     * Select the SMCLK as the source (TASSEL_2)
     * Divide the input by 1 (ID_0)
     * Timer A control mode count up (MC_1);
     */
    TA0CTL |= TASSEL_2| ID_0 | MC_1;


}

#pragma vector = TIMER0_A0_VECTOR
// Interrupt service routine for CCIFG0
__interrupt void TimerA0_routine(void)
{
    RGBLED_B_TGL;
}


